import { AbstractControlOptions, AsyncValidatorFn, FormBuilder, ValidatorFn } from '@angular/forms';
import { ClassType } from 'class-transformer/ClassTransformer';
import 'reflect-metadata';
import { DynamicFormBuilderOptions } from '../types/dynamic-form-builder-options';
import { DynamicFormGroupConfig } from '../types/dynamic-form-group-config';
import { FormModel } from '../types/form-model';
import { DynamicFormGroup } from './dynamic-form-group';
export declare class DynamicFormBuilder extends FormBuilder {
    private options?;
    private emptyDynamicFormGroup;
    constructor(options?: DynamicFormBuilderOptions | undefined);
    group<TModel>(factoryModel: ClassType<TModel>, controlsConfig?: FormModel<TModel> | DynamicFormGroupConfig | {
        [key: string]: any;
    }, options?: AbstractControlOptions | DynamicFormGroupConfig): DynamicFormGroup<TModel>;
    private factoryFormBuilder;
    factoryDynamicFormGroup<TModel>(factoryModel: ClassType<TModel>, fields?: FormModel<TModel>, validatorOrOpts?: ValidatorFn | ValidatorFn[] | AbstractControlOptions | null, asyncValidator?: AsyncValidatorFn | AsyncValidatorFn[] | null, options?: DynamicFormGroupConfig): DynamicFormGroup<TModel>;
    /**
     * Recursively creates an empty object from the data provided
     */
    private createEmptyObject;
}
